<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Message extends CI_Controller {

	function __construct() {
        parent::__construct();
		
		$this->lang->load('account_general', get_language());
		$this->load->model('member_model');
    }
	
	public function index()
	{
		save_current_url(base_url() . 'message/');
		
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_inbox_message');
			$this->member_model->member_read_message();
				
			$this->load->view('message', $data);
		}
		else {
			redirect('', 'refresh');
		}
	}
	
	public function details($message_id = NULL)
	{
		save_current_url(base_url() . 'message/details/' . $message_id . '/');
		
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			$data = $this->member_model->get_message_content($message_id);
			
			$data['page_title'] = $this->lang->line('website_name') . ' | ' . $this->lang->line('hf_inbox_message') . ' | ' . $this->lang->line('hf_message_details');
				
			$this->load->view('message_details', $data);
		}
		else {
			redirect('', 'refresh');
		}
	}
	
	public function getlist()
    {
		if($this->session->userdata('user_type') && $this->session->userdata('user_type') == MEMBER) {
			$this->lang->load('account_general', get_language());
		
			/* Array of database columns which should be read and sent back to DataTables. Use a space where
			 * you want to insert a non-database field (for example a counter or static image)
			 */
			 
			$aColumns = array(
								$this->db->dbprefix('member_messages') . '.created_date',
								$this->db->dbprefix('member_messages') . '.subject',
								$this->db->dbprefix('member_messages') . '.message_id',
							);
			
			// DB table to use
			$sTable = 'member_messages';
			//
			
			$this->db->where($this->db->dbprefix('member_messages') . '.member_id', $this->session->userdata('member_id'));
			
			$iDisplayStart = $this->input->get_post('iDisplayStart', true);
			$iDisplayLength = $this->input->get_post('iDisplayLength', true);
			$iSortCol_0 = $this->input->get_post('iSortCol_0', true);
			$iSortingCols = $this->input->get_post('iSortingCols', true);
			$sSearch = $this->input->get_post('sSearch', true);
			$sEcho = $this->input->get_post('sEcho', true);
		
			// Paging
			if(isset($iDisplayStart) && $iDisplayLength != '-1')
			{
				$this->db->limit($this->db->escape_str($iDisplayLength), $this->db->escape_str($iDisplayStart));
			}
			
			// Ordering
			if(isset($iSortCol_0))
			{
				for($i=0; $i<intval($iSortingCols); $i++)
				{
					$iSortCol = $this->input->get_post('iSortCol_'.$i, true);
					$bSortable = $this->input->get_post('bSortable_'.intval($iSortCol), true);
					$sSortDir = $this->input->get_post('sSortDir_'.$i, true);
		
					if($bSortable == 'true')
					{
						$this->db->order_by($aColumns[intval($this->db->escape_str($iSortCol))], $this->db->escape_str($sSortDir));
					}
				}
			}
			
			/* 
			 * Filtering
			 * NOTE this does not match the built-in DataTables filtering which does it
			 * word by word on any field. It's possible to do here, but concerned about efficiency
			 * on very large tables, and MySQL's regex functionality is very limited
			 */
			if(isset($sSearch) && !empty($sSearch))
			{
				for($i=0; $i<count($aColumns); $i++)
				{
					$bSearchable = $this->input->get_post('bSearchable_'.$i, true);
					
					// Individual column filtering
					if(isset($bSearchable) && $bSearchable == 'true')
					{
						$this->db->or_like($aColumns[$i], $this->db->escape_like_str($sSearch));
					}
				}
			}
			
			// Select Data
			$this->db->select('SQL_CALC_FOUND_ROWS '.str_replace(' , ', ' ', implode(', ', $aColumns)), false);
			$rResult = $this->db->get($sTable);
		
			// Data set length after filtering
			$this->db->select('FOUND_ROWS() AS found_rows');
			$iFilteredTotal = $this->db->get()->row()->found_rows;
		
			// Total data set length
			$iTotal = $this->db->count_all($sTable);
		
			// Output
			$output = array(
				'sEcho' => intval($sEcho),
				'iTotalRecords' => $iTotal,
				'iTotalDisplayRecords' => $iFilteredTotal,
				'aaData' => array()
			);
			
			foreach($rResult->result_array() as $aRow)
			{
				$row = array();
				
				$row[] = date('Y-m-d H:i:s', $aRow['created_date']);
				$row[] = $aRow['subject'];
				$row[] = '<a class="btn btn-primary btn-sm" href="' . base_url() . 'message/details/' . $aRow['message_id'] . '/">' . $this->lang->line('message_view') . '</a>';
				
				$output['aaData'][] = $row;
			}
		
			echo json_encode($output);
		}	
    }
}

/* End of file message.php */
/* Location: ./application/controllers/message.php */